#include "CFLogin.H"

#include "Logger.H"
extern Logger logger;

CFLogin::CFLogin(int wdth, int hght,bool brdr, bool shdw):
		Window(wdth,hght,brdr,shdw),
		_ready(false) {
	_rebld=true;
	_wtitle="Curfloo Login";
	_nameLabel.style(_stile);
	_passwdLabel.style(_stile);
	_roomLabel.style(_stile);
	_saveLabel.style(_stile);
	_statusLabel.style(_stile);
	_nameLabel.setText("Username:");
	_passwdLabel.setText("Password:");
	_roomLabel.setText("Room:");
	_saveLabel.setText("Save Login Information");
	_userTI=new TextInput(wdth-25,64);
	_passwdTI=new TextInput(wdth-25,64,true);
	_roomTI=new TextInput(wdth-25,128);
	_savestate=new Checkbox(false);
	(*_savestate).style(_stile);
	Window::add("User Label",&_nameLabel,7,3);
	Window::add("Passwd Label",&_passwdLabel,7,5);
	Window::add("Room Label",&_roomLabel,7,7);
	Window::add("Save Label",&_saveLabel,11,9);
	Window::add("Status",&_statusLabel,4,11);
	Window::add("User",_userTI,17,3);
	Window::add("Passwd",_passwdTI,17,5);
	Window::add("Room",_roomTI,17,7);
	Window::add("Save State",_savestate,7,9);
	_active=_userTI;
}

CFLogin::~CFLogin() {
	delete (_userTI);
	delete (_passwdTI);
	delete (_roomTI);
}

widstat CFLogin::input(Char inp) {
	if (inp.getSymbol() == 0x09) {
		if (_active==_userTI) {
			(*_active).outFocus();
			_active=_passwdTI;
			(*_active).inFocus();
		}
		else if (_active==_passwdTI) {
			(*_active).outFocus();
			_active=_roomTI;
			(*_active).inFocus();
		}
		else if (_active==_roomTI) {
			(*_active).outFocus();
			_active=NULL;
			(*_savestate).inFocus();
		}
		else {
			(*_savestate).outFocus();
			_active=_userTI;
			(*_active).inFocus();
		}
	}
	else if ((inp.isEnter()) && ((*_userTI).length()) &&
			((*_userTI).length()) && ((*_roomTI).length())) {
		_ready=true;
	}
	_rebld=true;
	if (_active)
		return ((*_active).input(inp));
	else
		return ((*_savestate).input(inp));
}

widstat CFLogin::style(Char stile) {
	_stile=stile;
	_nameLabel.style(_stile);
	_passwdLabel.style(_stile);
	_roomLabel.style(_stile);
	_saveLabel.style(_stile);
	(*_savestate).style(_stile);
	stile.tBold();
	stile.setFore(cc_yellow);
	_statusLabel.style(stile);
	_rebld=true;
	return (ws_accepted);
}

int CFLogin::setInfo(const string &user, const string &passwd,
		const string &room, bool savedata, bool ready) {
	(*_userTI).set(user);
	(*_passwdTI).set(passwd);
	(*_roomTI).set(room);
	(*_savestate).setChecked(savedata);
	if (user.length()) {
		if (_active)
			(*_active).outFocus();
		_active=_passwdTI;
		(*_active).inFocus();
	}
	if (passwd.length()) {
		if (_active)
			(*_active).outFocus();
		_active=_roomTI;
		(*_active).inFocus();
	}
	_ready=ready;
	return 0;
}

int CFLogin::getInfo(string &user, string &passwd,string &room,bool &savedata) {
	_rebld=true;
	user=(*_userTI).get().getString();
	passwd=(*_passwdTI).get().getString();
	room=(*_roomTI).get().getString();
	savedata=(*_savestate).isChecked();
	if (_ready) {
		_ready=false;
		return 0;
	}
	else
		return 1;
}

int CFLogin::setStatusMessage(const string txt) {
	_statusLabel.setText(txt);
	_rebld=true;
	return 0;
}
