#ifndef __CFMAINWIN_H__
#define __CFMAINWIN_H__

#include "StrList.H"
#include "StrPairList.H"
#include "TextArea.H"
#include "TextInput.H"
#include "MenuBar.H"
#include "Window.H"
#include "TextWin.H"
#include "YahooProto.H"
#include "CFChattersWin.H"
#include "CFPMListWin.H"
#include "CFChatArea.H"
#include "CFCommand.H"
#include "CFMenu.H"
#include "CFStatusBar.H"
#include "CFThrottle.H"
#include "CFConsole.H"
#include "CFAbout.H"
#include "CFProfile.H"
#include "CFLogin.H"
#include "Logger.H"

enum inputtype { it_normal, it_kshvi, it_bash };

class CFMainWin: public Window, private Menu {
	public:
		CFMainWin(int wdth, int hght,const string &user, const string &passwd,
				const string &room);
		~CFMainWin();
		widstat input(Char inp);	
		int run();
	private:
		YahooProto _yp;
		CFConsole *_tracelog;
		CFLogin *_login;
		CFMenu *_menu;
		CFAbout *_about;
		TextWin *_help;
		TextWin *_awayhelp;
		CFPMListWin *_pmlistwin;
		CFChattersWin *_rl;
		CFStatusBar *_statb;
		CFThrottle *_throttle;
		CFCommand *_command;
		CFChatArea *_chatarea;
		CFProfile *_profile;
		Widget *_active;
		StrList _buddies;
		StrList _peeps;
		StrList _ailist;
		StrList *_tiggy;
		StrList *_piggy;
		StrPairList _repost;
		StrPairList *_config;
		TextInput *_ti;
		Logger *_chatlog;
		bool _signedon;
		bool _done;
		bool _quitonsignoff;
		int _intmax;
		bool _getonline;
		bool _getoffline;
		bool _forcedoffline;
		bool _stripnl;
		bool _autoiggy;
		bool _wraptxt;
		bool _forcelower;
		inputtype _inptype;
		string _user;
		string _passwd;
		string _room;
		pthread_mutex_t _inplock;

		CFMainWin(const CFMainWin &);
		CFMainWin &operator=(const CFMainWin &);
		
		void configure(const string &user, const string &passwd,
				const string &room);
		int handleMenuItem(const string &name, const StrList params="");
		bool isActiveMenuItem(const string &name);
		string menuItemText(const string &name);
		int getOnline();
		int dispatchEvent(const YahooMessage &msg);
		int dispatchSpeech(YahooMessage &msg);
		int grep(const string &pattern, const string &str);
};

#endif // __CFMAINWIN_H__
