#include "Menu.H"
#include "Logger.H"

extern Logger logger;

Menu::Menu(int wdth):
		_width(wdth>0?wdth:0),
		_elements(0),
		_totalwidth(_width),
		_totalheight(_elements),
		_active(-1),
		_fixedw(wdth>0),
		_changed(true) {
	_parent=new Grid(_width,_elements);
	_whole=new Grid(_totalwidth,_totalheight);
}

Menu::~Menu() {
	delete(_whole);
	delete(_parent);
}

widstat Menu::style(Char chr) {
	Menu
		*mp;

	_stile=chr;
	for (int i=0; i < (signed)_elements; i++) {
		if ((mp=(Menu *)_itemlist.get(i))!=NULL) {
			(*mp).style(chr);
		}
	}
	_changed=true;
	return (ws_accepted);
}

widstat Menu::gotFocus() { 
	Menu
		*mp;
	string
		s;

	for (int i=0; i < (signed)_elements; i++) {
		if (((mp=(Menu *)_itemlist.get(i,s))!=NULL) &&
			((*mp).isActiveMenuItem(s))) {
			_active=i;
			return (ws_accepted);
		}
	}
	return (ws_rejected);
}

void Menu::lostFocus() {
}

widstat Menu::input(Char chr) {
	Menu
		*mp=NULL;
	Char
		activator;
	widstat
		rv;
	int
		i=0,
		x,y;
	bool
		mvd,vis;
	string
		s;

	if ((_active >= 0) && ((mp=(Menu *)_itemlist.get(_active,s))!=NULL) &&
			((*mp).elements()) && ((*mp).isFocused())) {
		if ((rv=(*mp).input(chr))==ws_completed) {
			return (ws_completed);
		}
		if (rv==ws_cancelled) {
			for (i=(_active+1); i < (signed)_elements; i++) {
				if (((mp=(Menu *)_itemlist.get(i,s))!=NULL) &&
					((*mp).isActiveMenuItem(s))) {
					_active=i;
					(*mp).inFocus();
					return (ws_accepted);
				}
			}
			for (i=(_active-1); i >= 0; i--) {
				if (((mp=(Menu *)_itemlist.get(i,s))!=NULL) &&
					((*mp).isActiveMenuItem(s))) {
					_active=i;
					(*mp).inFocus();
					return (ws_accepted);
				}
			}
			return (ws_cancelled);
		}
		return (ws_accepted);
	}
	if ((chr.isUpArrow()) && (_active > 0)) {
		for (i=(_active-1); i >= 0; i--) {
			if (((mp=(Menu *)_itemlist.get(i,s))!=NULL) &&
				((*mp).isActiveMenuItem(s))) {
				_active=i;
//				(*mp).inFocus();
				return (ws_accepted);
			}
		}
	}
	if ((chr.isDownArrow()) && (_active < (signed)(_elements-1))) {
		for (i=(_active+1); i < (signed)_elements; i++) {
			if (((mp=(Menu *)_itemlist.get(i,s))!=NULL) &&
				((*mp).isActiveMenuItem(s))) {
				_active=i;
				(*mp).inFocus();
				return (ws_accepted);
			}
		}
	}
	if (chr.isEnter()) {
		mp=(Menu *)_itemlist.get(_active,s);
		if (mp) {
			if ((*mp).elements()) {
				(*mp).inFocus();
				return (ws_accepted);
			}
			else {
				(*mp).handleMenuItem(s);
				return (ws_completed);
			}
//HERE
		}
	}
	if (chr.isEsc()) {
		outFocus();
		return (ws_cancelled);
	}
	else {
		for (i=0; i < _itemlist.size(); i++) {
			mp=(Menu *)_itemlist.get(i,s,x,y,mvd,vis,activator);
			if ((mp) && (activator.actsLike(chr))) {
				if ((*mp).isActiveMenuItem(s)) {
					(*mp).handleMenuItem(s);
					return (ws_completed);
				}
				else
					break;
			}
		}
	}
	return (ws_rejected);
}

const Grid &Menu::draw() {
	Menu *mp, *sub;
	Text t;
	Char c,activator;
	int x,y,isub;
	bool mvd,vis;
	
	string name;
	string label;

	c.setTransparent();
	(*_whole).fill(c);
	(*_parent).fill(_stile);
	sub=NULL;
	isub=0;
	for (unsigned int i=0; i<_elements; i++) {
		mp=(Menu *)_itemlist.get(i,name,x,y,mvd,vis,activator);
		if (mp) {
			label=(*mp).menuItemText(name);
			if (label.length() > _width) {
				Grid *grow;
				_totalwidth+=label.length()-_width;
				_width=label.length();
				grow=new Grid(_width,_elements);
				(*grow).fill(_stile);
				(*grow).set(0,0,(*_parent));
				delete _whole;
				_whole=new Grid(_totalwidth,_totalheight);
				delete _parent;
				_parent=grow;
			}
		}
		else {
			label=name;
		}
		t.style(_stile);
		c=_stile;
		if (mp) {
			if ((signed)i==_active) {
				c.tStandout();
				if (!c.isStandout())
					c.tBold();
				t.style(c);
				t.setText(label);
				t.setUnderline(activator);
				(*_parent).fill(c,i);
				sub=mp;
				isub=i;
			}
			else if ((*mp).isActiveMenuItem(name)) {
				t.style(c);
				t.setText(label);
				t.setUnderline(activator);
			}
			else {
				c.setBack(cc_black);
				t.style(c);
				t.setText(label);
				t.setUnderline(activator);
			}
		}
		else {
			c.setBack(cc_black);
			t.style(c);
			t.setText(label);
			t.setUnderline(activator);
		}
		(*_parent).set(0,i,t.draw());
	}
	(*_whole).set(0,0,(*_parent));
	if ((sub) && ((*sub).elements()) && ((*sub).isFocused())) {
		if (((_width+(*sub).width())>_totalwidth) ||
			((_elements+(*sub).height())>_totalheight)) {
			if ((_width+(*sub).width())>_totalwidth)
				_totalwidth=_width+(*sub).width();
			if ((_elements+(*sub).height())>_totalheight)
				_totalheight=_elements+(*sub).height();
			Grid *grow;	
			grow=new Grid(_totalwidth,_totalheight);
			(*grow).set(0,0,(*_parent));
			delete _parent;
			_parent=grow;
		}
		(*_whole).set(_width,isub+1,(*sub).draw());
	}
	_changed=false;
	return (*_whole);
}

int Menu::addMenuItem(const string txt, Menu *menuitem, Char activator) {
	delete (_parent);
	delete (_whole);
	if ((!_fixedw) && (txt.length() > _width)) {
		_totalwidth+=(txt.length() - _width);
		_width=txt.length();
	}
	_elements++;
	_totalheight++;
	if ((menuitem) && ((*menuitem).elements())) {
		if ((_width+(*menuitem).width())>_totalwidth)
			_totalwidth=_width+(*menuitem).width();
		if ((_elements+(*menuitem).height()+1)>_totalheight)
			_totalheight=_elements+(*menuitem).height();
	}
	_parent=new Grid(_width,_elements);
	_whole=new Grid(_totalwidth,_totalheight);
	return (_itemlist.add(txt,menuitem,0,_elements,activator));
}
