#include "MenuBar.H"
#include "Text.H"

#include "Logger.H"
extern Logger logger;

MenuBar::MenuBar(unsigned int wdth):
	_grd(NULL),
	_width(wdth),
	_height(1),
	_loff(1),
	_roff(_width-1),
	_active(-1),
	_changed(true) {
	_grd=new Grid(_width,_height);
}
		
MenuBar::~MenuBar() {
	delete (_grd);
}

widstat MenuBar::gotFocus() {
	Widget
		*wp=_itemlist.get((_active=0));
	if (wp)
		(*wp).inFocus();
	return (ws_accepted);
}

void MenuBar::lostFocus() {
	_active=-1;
}

widstat MenuBar::input(Char chr) {
	Widget
		*wp=_itemlist.get(_active);

	for (int i=0; i < _itemlist.size(); i++) {
		Widget *nwp;
		Char activator;
		int x,y;
		bool mvd, vis;
		string name;	
		nwp=_itemlist.get(i,name,x,y,mvd,vis,activator);
		if (activator.actsLike(chr)) {
			inFocus();
			if (wp)
				(*wp).outFocus();
			_active=i;
			wp=nwp;
			(*wp).inFocus();
			return (ws_accepted);
		}
	}
	if (_active >= 0) {
		if (chr.isRightArrow()) {
			if (wp)
				(*wp).outFocus();
			if (++_active==_itemlist.size())
				_active=0;
			if ((wp=_itemlist.get(_active))!=NULL)
				(*wp).inFocus();
			return (ws_accepted);
		}
		if (chr.isLeftArrow()) {
			if (wp)
				(*wp).outFocus();
			if (--_active==-1)
				_active=_itemlist.size()-1;
			if ((wp=_itemlist.get(_active))!=NULL)
				(*wp).inFocus();
			return (ws_accepted);
		}
		if (wp) {
			widstat
				rv=(*wp).input(chr);
			if (rv==ws_completed) {
				outFocus();
				return (ws_accepted);
			}
			if (rv==ws_accepted) {
				return (ws_accepted);
			}
			if (rv==ws_cancelled) {
				outFocus();
				return (ws_accepted);
			}
		}
		if (chr.isEsc()) {
			outFocus();
			return (ws_accepted);
		}
	}
	return (ws_rejected);
}

const Grid &MenuBar::draw() {
	Char
		activator,
		c;
	Text
		t;
	Widget
		*wp;
	string
		name;
	int
		x, y;
	bool
		mvd,
		vis;

	c.setTransparent();
	(*_grd).fill(c);	
	c=_stile;
	t.style(c);
	(*_grd).fill(c,0);	
	for (int i=0; i< _itemlist.size(); i++) {
		wp=_itemlist.get(i,name,x,y,mvd,vis,activator);
		if (i==_active) {
			c.tStandout();
			if (!c.isStandout())
				c.tBold();
			t.style(c);
			t.setText(name);
			t.setUnderline(activator);
			(*_grd).set(x,y,t.draw());
			if (!c.isStandout())
				c.tBold();
			c.tStandout();
			t.style(c);
		}
		else {
			t.setText(name);
			t.setUnderline(activator);
			(*_grd).set(x,y,t.draw());
		}
	}
	if (_active >= 0) {
		wp=_itemlist.get(_active,name,x,y,mvd,vis,activator);
		if ((x+(*wp).width()) > _width)
			x=_width-(*wp).width();
		(*_grd).set(x,y+1,(*wp).draw());
	}
	return (*_grd);
}

widstat MenuBar::style(Char chr) {
	Widget
		*wp;
	_stile=chr;
	for (int i=0; i< _itemlist.size(); i++) {
		wp=_itemlist.get(i);
		(*wp).style(_stile);
	}
}

int MenuBar::addMenu(string name, Menu *wgt, Char activator,
			bool alignright) {
	int rv;
	if (((*wgt).height()+1) > _height) {
		_height=(*wgt).height()+1;
		delete(_grd);
		_grd=new Grid(_width,_height);
	}
	if (alignright) {
		rv=_itemlist.add(name,wgt,_roff-name.length(),0,activator);
		_roff-=(name.length()+3);
	}
	else {
		rv=_itemlist.add(name,wgt,_loff,0,activator);
		_loff+=(name.length()+3);
	}
	return (rv);
}
