#ifndef __SOCKET_H__
#define __SOCKET_H__

#include <stdio.h>
#include <string>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <pthread.h>

using namespace std;

class Socket {
	public:
		Socket(const string &host,unsigned short port, long flags=0L);
		virtual ~Socket();
		virtual int open();
		virtual void close();
		virtual int read(char *buf, unsigned int count, int waitsecs=0);
		virtual int write(const char *buf, unsigned int len, int waitsecs=0);
		virtual int setNonBlock();
	protected:
		virtual int activateFlags();
		virtual FILE *getOutputStream(void) { return (_inputstream); };
		virtual FILE *getInputStream(void) { return (_outputstream); };
	private:
		int _sockfd;
		int _errno;
		long _flags;
		FILE *_outputstream;
		FILE *_inputstream;
		string _host;
		unsigned short _port;
		struct sockaddr_in _serv_addr;
		pthread_mutex_t _rlock;
		pthread_mutex_t _wlock;

		Socket(const Socket &);
		Socket &operator=(const Socket &);
};

#endif // __SOCKET_H_
