#ifndef __STRLIST_H__
#define __STRLIST_H__

#include <pthread.h>
#include <string>
#include <list>

using namespace std;

class StrList {
	public:
		StrList(bool sort=true);
		StrList(const StrList &sl);
		StrList &operator=(const StrList &sl);
		StrList &operator=(const string first);
		virtual ~StrList();
		virtual int add(const string &str);
		virtual int add(const StrList &strlist);
		virtual int remove(const string &str);
		virtual int remove(unsigned int idx);
		virtual bool inlist(const string &str) const;
		virtual string operator[](unsigned int idx) const;
		virtual unsigned int size() const { return _list.size(); }
	protected:
		virtual void clear() { tlock(); _list.clear(); tunlock(); }
		int tlock() const { pthread_mutex_lock(&_lock); return 0; }
        int tunlock() const { pthread_mutex_unlock(&_lock); return 0; }
		bool _sort;
	private:
		mutable pthread_mutex_t _lock;
		list<string> _list;
};

#endif // __STRLIST_H__
