#ifndef __STRPAIRLIST_H__
#define __STRPAIRLIST_H__

#include "StrList.H"
#include <string>
//#include <map>

class StrPairListMap;

class StrPairList {
	public:
		StrPairList();
		StrPairList(const StrPairList &ul);
		StrPairList &operator=(const StrPairList &ul);
		virtual ~StrPairList();
		virtual int add(const string &key, const string &data);
		virtual int remove(const string &key);
		virtual bool inlist(const string &key) const;
		virtual int get(const string &key, string &data) const;
		virtual int get(unsigned int idx, string &key, string &data) const;
		virtual string operator[](unsigned int idx) const;
		virtual unsigned int size() const;
	protected:
		virtual void clear();
		int tlock() const { pthread_mutex_lock(&_lock); return 0; }
		int tunlock() const { pthread_mutex_unlock(&_lock); return 0; }
	private:
		mutable pthread_mutex_t _lock;
		//map<string,string> _list;
		StrPairListMap *_list;
};

#endif // __STRPAIRLIST_H__
