#include "StrUtil.H"
#include <unistd.h>
#include <regex.h>

int StrUtil::grep(const string &pattern, const string &str) {
	static regex_t preg[16383];

	if (regcomp(preg,pattern.c_str(),REG_EXTENDED|REG_NOSUB)) {
		return -1;
	}
	return (regexec(preg,str.c_str(),0,NULL,0));
}

int StrUtil::straightReplace(const string pattern, const string replacewith,
                string &str, bool global) {
	int idx;
	int counter=0;
	while ((idx=str.find(pattern)) > -1) {
		str.replace(idx,pattern.length(),replacewith);
		counter++;
		if (!global)
			break;
	}
	return (counter);
}

int StrUtil::findTagBounds(const char *haystack, const char *needle,
         int &strt, int &end) {
	const char *ptr=haystack;
	const char *bptr;
	while ((ptr=strchr(ptr,'<'))!=NULL) {
		if ((needle) && (strncasecmp(ptr+1,needle,strlen(needle)))) {
			ptr++;
			continue;
		}
		bptr=(ptr+strlen(needle?needle:"")+1);
		if ((needle) && (!((*bptr==0x20) || (*bptr==0x09) || (*bptr=='>')))) {
			ptr++;
			continue;
		}
		strt=(ptr-haystack);
		if ((bptr=strchr(bptr,'>'))==NULL) {
			return -2;
		}
		bptr++;
		end=(bptr-haystack);
		return 0;
	}
	return -1;
}

bool StrUtil::isSmiley(const string &pattern) {
	char
		c1=pattern[0],
		c2=pattern[1],
		c3=pattern[2];

	if ((c1 != ':') && (c1 != ';'))
		return false;
	if (((c2==')') || (c2=='D') || (c2=='P') || (c2=='p') ||
		(c2=='|') || (c2=='(') || (c2=='X') || (c2=='x') ||
		(c2=='>')) && !(((c3>='A') && (c3<='Z')) ||
		((c3>='a') && (c3<='z')) || ((c3>='0') && (c3<='9'))))
		return true;
	else
		return false;
}
