#include "Text.H"
#include <algorithm>

#include "Logger.H"
extern Logger logger;

Text::Text(const char *str, unsigned int maxlen, bool bow):
	_igAttr(false),
	_ul(false),
	_bold(false),
	_changed(true),
	_lines(1),
	_stile(0x20),
	_grd(NULL) {
	if (str)
		setText(str,maxlen,bow);
}

Text::Text(const Text &t):
	Widget(t),	
	_igAttr(t._igAttr),
	_ul(t._ul),
	_bold(t._bold),
	_changed(true),
	_lines(t._lines),
	_stile(t._stile),
	_grd(NULL),
	_txt(t._txt) {
}

Text::~Text() {
	if (_grd)
		delete (_grd);
}

const Grid &Text::draw() {
	if (_grd)
		delete (_grd);
	tlock();
	Char c;
	_grd=new Grid(length(),1);	
	for (unsigned int i=0; i<length(); i++) {
		c=_txt[i];
		if (c.getFore()==cc_undef)
			c.setFore(_stile.getFore());
		if (c.getBack()==cc_undef)
			c.setBack(_stile.getBack());
		(*_grd).set(i,0, c);
	}
	tunlock();
	_changed=false;	
	return (*_grd);
}

Text &Text::operator=(const Text &t) {
	_igAttr=t._igAttr;
	_ul=t._ul;
	_bold=t._bold;
	_changed=true;
	_lines=t._lines;
	_stile=t._stile;
	tlock();
	_txt=t._txt;
	tunlock();
	return (*this);
}

Text &Text::operator+=(const Text &t) {
	tlock();
	for (unsigned int i=0; i < t.length(); i++)
		_txt.push_back(t[i]);
	_lines=lineCount();
	tunlock();
	_changed=true;
	return (*this);
}

int Text::setText(const string &str, unsigned int maxlen,bool bow) {
	unsigned int
		conv,
		offset=0,
		obound=0;
	Char
		chr;

	if (!maxlen)
		maxlen=str.length();
	chr.setLike(_stile);
	conv=0;
//	if (str[offset]=='\n') {
//		return -1;
//	}
	tlock();
	_txt.clear();
	for (; offset < str.length(); offset++) {
		if (offset==maxlen) {
			if ((bow) && (obound)) {
				while(_txt[_txt.size()-1]!=0x20)
					_txt.pop_back();
				offset=obound;
				break;
			}
			break;
		}
		else if ((str[offset]==0x20) || (str[offset]==0x09)) {
			obound=offset;
			chr=0x20;
			_txt.push_back(chr);
		}
		else {
			chr=str[offset];
			_txt.push_back(chr);
		}
	}
	_lines=lineCount();
	tunlock();
	_changed=true;
	return (offset);
}

int Text::setText(const char *str, unsigned int maxlen,bool bow) {
	string
		rstr=str;

	return (setText(rstr,maxlen,bow));
}

Text Text::chop(unsigned int col, bool bow, bool skipnl) {
	Text
	//	f,
		tmp;
	Char
		chr=0x20;
	int
		bound=0;

//this function *should* be using some variation of find
//all this mess cuz im not savvy with the STL/Iterators
	//f=(*this);
	tlock();
	if (!skipnl) {
		for (unsigned int j=0;((j <= col) && (j < length())); j++) {
			if (_txt[j].getSymbol() == '\n') {
				if ((j+1) < length())
					bound=j+1;
				break;
			}
		}
		if (bound) {
			vector<Char>::iterator
				hack= _txt.begin() + bound;
			for (vector<Char>::iterator i=hack; i < _txt.end(); i++) {
				tmp._txt.push_back(*i);
			}
			_txt.erase(hack,_txt.end());
			_lines=lineCount();
			tunlock();
			_changed=true;
			return tmp;
		}
	}
	bound=col;
	if (col < length()) {
		if (bow) {
			while(bound) {
				if (_txt[bound].isBlank()) {
					break;
				}
				bound--;
			}
			if (!bound)
				bound=col;
		}
		vector<Char>::iterator
			hack= _txt.begin() + bound;
		for (vector<Char>::iterator i=hack; i < _txt.end(); i++) {
			tmp._txt.push_back(*i);
		}
		_txt.erase(hack,_txt.end());
		//reverse(tmp._txt.begin(),tmp._txt.end());	
	}
	_lines=lineCount();
	tunlock();
	_changed=true;
	return tmp;
}

int Text::insert(Char c, unsigned int col) {
	if (col > (_txt.size()))
		return -1;
	if (col == _txt.size()) {
		operator+=(c);
		return 0;
	}
	tlock();
	vector<Char>::iterator
		hack= _txt.begin() + col;
	_txt.insert(hack,c);
	if (c.getSymbol() == '\n')
		_lines++;
	tunlock();
	_changed=true;
	return 0;
}

int Text::replace(Char c, unsigned int col) {
	if (col > (_txt.size()-1))
		return -1;
	tlock();
	vector<Char>::iterator
		hack= _txt.begin() + col;
	if (((*hack).getSymbol()=='\n') && (c.getSymbol()!='\n'))
		_lines--;
	if (((*hack).getSymbol()!='\n') && (c.getSymbol()=='\n'))
		_lines++;
	*hack=c;
	tunlock();
	_changed=true;
	return 0;
}

int Text::erase(unsigned int col) {
	if (col > (_txt.size()-1))
		return -1;
	tlock();
	vector<Char>::iterator
		hack= _txt.begin() + col;
	_txt.erase(hack);
	_lines=1;
	tunlock();
	_changed=true;
	return 0;
}

int Text::padLeft(char chr, unsigned int amount) {
	unsigned int
		i;
	Char
		pad;

	pad=chr;	
	pad.setLike(_stile);
	tlock();
	while ((_txt.size()) && ((_txt[0]==0x09) || (_txt[0]==0x20))) {
		_txt.erase(_txt.begin());
	}
	for (i=0; i < amount; i++) {
		_txt.insert(_txt.begin(),pad);
	}
	tunlock();
	_changed=true;
	return 0;
}

int Text::padRight(char chr, unsigned int amount) {
	Char
		pad;

	pad=chr;	
	pad.setLike(_stile);
	tlock();
	while (_txt.size() < amount)
		_txt.push_back(pad);
	tunlock();
	_changed=true;
	return 0;
}

int Text::stripRight(char chr) {
	tlock();
	while (_txt.size() && (_txt.back()==chr))
		_txt.pop_back();
	tunlock();
	_changed=true;
	return 0;
}

int Text::setUnderline(Char chr) {
	for (vector<Char>::iterator i=_txt.begin(); i < _txt.end(); i++) {
		if ((*i).getUpperSymbol() == chr.getUpperSymbol()) {
			(*i).tUnderline();
			return 0;
		}
	}
	return -1;
}

string Text::getString() const {
	string
		str;

	tlock();
	for (unsigned int i=0;i<length();i++) {
		str+=_txt[i].getSymbol();
	}
	tunlock();
	return (str);
}

unsigned int Text::lineCount() {
	unsigned int lns=1;
	for (unsigned int i=0; i < length(); i++) {
		if (_txt[i].getSymbol()=='\n')
			lns++;
	}
	return lns;
}
