#ifndef __TEXT_H__
#define __TEXT_H__

#include "Char.H"
#include "Grid.H"
#include "Widget.H"
#include <string>
#include <vector>
#include <pthread.h>

using namespace std;

class Text: public Widget {
	public:
		Text(const char *str=NULL,unsigned int maxlen=0, bool bow=false);
		Text(const Text &t);
		virtual ~Text();
		virtual widstat input(Char chr) {
				chr.isNormal(); return (ws_rejected); }
		virtual const Grid &draw();
		virtual bool update() { return (_changed); }
		virtual unsigned int height() const { return (1); }	
		virtual unsigned int width() const { return (length()); }	
		virtual unsigned int lines() const { return (_lines); }	
		virtual widstat style(Char chr) { 
				_stile=chr;_changed=true; return ws_accepted; }
		virtual Text &operator=(const Text &t);
		virtual Text &operator+=(const Text &t);
		virtual Text &operator=(const Char &c) { if (c.isPrintable()) {
				_txt.clear(); _txt.push_back(c);
				if (c.getSymbol()=='\n') _lines++; } return (*this); }
		virtual Text &operator+=(const Char &c) { if (c.isPrintable()) {
				_txt.push_back(c); if (c.getSymbol()=='\n') _lines++; }
				return (*this); }
		virtual Char operator[](int idx) const{ return _txt[idx]; }
		virtual int setText(const string &str,unsigned int maxlen=0,
				bool bow=false);
		virtual int setText(const char *,unsigned int maxlen=0, bool bow=false);
		virtual Text chop(unsigned int col, bool bow=false, bool skipnl=true);
		virtual int insert(Char c, unsigned int col=0);
		virtual int replace(Char c, unsigned int col=0);
		virtual int erase(unsigned int col);
		virtual int setUnderline(Char chr);
		virtual int padLeft(char chr, unsigned int amount);
		virtual int padRight(char chr, unsigned int amount);
		virtual int stripRight(char chr);
		virtual string getString() const;
		virtual unsigned int length() const { return (_txt.size()); }
	protected:
		bool _igAttr;
		bool _ul;
		bool _bold;
		bool _changed;
		unsigned int _lines;
		Char _stile;
		Grid *_grd;
		vector <Char> _txt;
		unsigned int lineCount();
};

#endif // __TEXT_H__
