#ifndef __TEXTINPUT_H__
#define __TEXTINPUT_H__

#include "Widget.H"
#include "Text.H"
#include "StrList.H"
#include <deque>

class TextInput:public Widget {
	public:
		TextInput(unsigned int wdth, unsigned int maxlen=0, bool secret=false); 
		TextInput(unsigned int wdth, unsigned int maxlen, StrList &matchlist); 
		virtual ~TextInput();
		virtual widstat input(Char chr);
		virtual const Grid &draw();
		virtual bool update() { return (_changed||_focused); }
		virtual unsigned int height() const { return (1); }
		virtual unsigned int width() const { return (_width); }
		virtual unsigned int length() const { return (_line.length()); }
		virtual widstat style(Char stile);
		virtual widstat gotFocus();
		virtual void lostFocus();
		virtual void reset();
		virtual unsigned int curLeft() { if (_index) _index--; return _index; }
		virtual unsigned int curRight() { 
				if (_index<_maxlen) _index++; return _index; }
		virtual unsigned int curSet(unsigned int cur) {
				if (_index<_maxlen) _index=cur; return _index; }
		virtual unsigned int curPos() { return _index; }
		virtual void set(const string &txt);
		virtual void set(const Text &txt);
		virtual void set(const Char chr, int pos=-1);
		virtual Text get() { return (_line); }
		virtual int erase(int pos=-1) { return (_line.erase(pos)); }
		virtual int insert(const Char chr, int pos=-1) {
				return (_line.insert(chr,pos)); }
		virtual int setHistorySize(unsigned int size) {
				_maxhist=size; return 0; }
		virtual int setFromHistory(unsigned int idx);
		virtual unsigned int currentHistorySize(){ return (_history.size()); }
		virtual int findWordBegin(int word, unsigned int position=0);
		virtual int findWordEnd(int word, unsigned int position=0);
		virtual int match(const string &str, const StrList &matchlist,
				string &comp);
		virtual int matchInPlace(const StrList &matchlist, int idxoffset=0);
	protected:
		Grid *_grd;
		Text _line;
		Text _tmpline;
		bool _secret;
		Char _stile;
		Char _cursor;
		bool _focused;
		unsigned int _width;
		unsigned int _maxlen;
		unsigned int _index;
		unsigned int _hindex;
		bool _enhanced;
		bool _complete;
		bool _changed;
		StrList *_matchlist;
		deque<Text> _history;
		unsigned int _maxhist;
	private:
		void init(unsigned int wdth, unsigned int maxlen, bool secret,
				StrList *matchlist);
		TextInput(const TextInput &);
		TextInput &operator=(const TextInput &);
};

#endif // __TEXTINPUT_H__
