#ifndef __WIDGET_H__
#define __WIDGET_H__

#include "Char.H"
#include "Grid.H"

#include <pthread.h>

enum widstat {ws_accepted, ws_rejected, ws_completed, ws_cancelled, ws_invalid};

class Widget {
	public:
		widstat inFocus() { if (gotFocus()==ws_accepted) {
				_focus=true; return (ws_accepted); }
				else return (ws_rejected); }
		void outFocus() { _focus=false; lostFocus(); }
		bool isFocused() { return (_focus); }
		virtual widstat input(Char chr) =0;
		virtual const Grid &draw() =0;
		virtual bool update() =0;
		virtual unsigned int height() const =0;
		virtual unsigned int width() const =0;
		virtual widstat style(Char chr) =0;
	protected:
		Widget():_focus(false) { pthread_mutex_init(&_lock,NULL); }
		Widget(const Widget &wg):_focus(wg._focus) {
				 pthread_mutex_init(&_lock,NULL); }
		virtual ~Widget() { pthread_mutex_destroy(&_lock); }
		virtual widstat gotFocus() { return (ws_rejected); }
		virtual void lostFocus() { }
		int tlock() const { pthread_mutex_lock(&_lock); return 0; }
		int tunlock() const { pthread_mutex_unlock(&_lock); return 0; }
	private:
		Widget &operator=(const Widget &);
		mutable pthread_mutex_t _lock;
		bool _focus;
};

#endif // __WIDGET_H__
