#include "WidgetList.H"

int WidgetList::add(const string title, Widget *wgt, int x, int y,
		Char activator) {
	widdata
		wd;

	wd.widp=wgt;
	wd.name=title;
	wd.x=x;
	wd.y=y;
	wd.moved=false;
	wd.visible=true;
	wd.activator=activator;
	_list.push_back(wd);
	return 0;
}

int WidgetList::remove(const string &title) {
	tlock();
	for (deque<widdata>::iterator i=_list.begin(); i < _list.end(); i++) {
		if (((*i).name) == title) {
			_list.erase(i);
			tunlock();
			return 0;
		}
	}
	tunlock();
	return -1;
}

Widget *WidgetList::get(unsigned int idx) {
	Char
		activator;
	int
		tmpx,
		tmpy;
	bool
		mvd,
		vis;
	string
		title;
	return (get(idx,title,tmpx,tmpy,mvd,vis,activator));
}

Widget *WidgetList::get(unsigned int idx, string &title) {
	Char
		activator;
	int
		tmpx,
		tmpy;
	bool
		mvd,
		vis;
	return (get(idx,title,tmpx,tmpy,mvd,vis,activator));
}

Widget *WidgetList::get(const string title) {
	Char
		activator;
	unsigned int
		idx;
	int
		tmpx,
		tmpy;
	bool
		mvd,
		vis;
	return (get(title,idx,tmpx,tmpy,mvd,vis,activator));
}

Widget *WidgetList::get(unsigned int idx, string &title, int &x, int &y,
		bool &mvd, bool &visible, Char &activator) {
	widdata
		wd;

	tlock();
	if (idx >= _list.size()) {
		tunlock();
		return NULL;
	}
	tunlock();
	wd=_list[idx];
	title=wd.name;
	x=wd.x;
	y=wd.y;
	mvd=wd.moved;
	visible=wd.visible;
	activator=wd.activator;
	return (wd.widp);
}

Widget *WidgetList::get(const string &title, unsigned int &idx, int &x,
		int &y, bool &mvd, bool &visible, Char &activator) {
	widdata
		wd;
	tlock();
	for (unsigned int i=0; i < _list.size(); i++) {
		wd=_list[i];	
		if ((wd.name) == title) {
			tunlock();
			idx=i;
			x=wd.x;
			y=wd.y;
			mvd=wd.moved;
			visible=wd.visible;
			activator=wd.activator;
			return (wd.widp);
		}
	}
	tunlock();
	return NULL;
}

int WidgetList::getIndex(const string &title) {
	widdata
		wd;

	tlock();
	for (unsigned int i=0; i < _list.size(); i++) {
		wd=_list[i];	
		if ((wd.name) == title) {
			tunlock();
			return i;
		}
	}
	tunlock();
	return -1;
}

int WidgetList::show(const string title) {
	int
		idx;

	idx=getIndex(title);
	if (idx < 0)
		return -1;
	return (show(idx));
}

int WidgetList::show(unsigned int idx) {
	deque<widdata>::iterator
		pinc;
	unsigned int
		i;

	tlock();
    if (idx >= _list.size()) {
		tunlock();
        return -1;
	}
	for (i=0, pinc=_list.begin(); i<idx; pinc++,i++);
	(*pinc).visible=true;
	tunlock();
	return 0;
}

int WidgetList::hide(const string title) {
	int
		idx;

	idx=getIndex(title);
	if (idx < 0)
		return -1;
	return (hide(idx));
}

int WidgetList::hide(unsigned int idx) {
	deque<widdata>::iterator
		pinc;
	unsigned int
		i;

	tlock();
    if (idx >= _list.size()) {
		tunlock();
        return -1;
	}
	for (i=0, pinc=_list.begin(); i<idx; pinc++,i++);
	(*pinc).visible=false;
	(*pinc).moved=true;
	tunlock();
	return 0;
}

bool WidgetList::isVisible(const string title) {
	int
		idx;

	idx=getIndex(title);
    if (idx < 0) {
        return false;
	}
	return (isVisible(idx));
}

bool WidgetList::isVisible(unsigned int idx) {
	deque<widdata>::iterator
		pinc;
	bool
		vis;
	unsigned int
		i;

	tlock();
    if (idx >= _list.size()) {
		tunlock();
        return false;
	}
	for (i=0, pinc=_list.begin(); i<idx; pinc++,i++);
	vis=(*pinc).visible;
	tunlock();
	return (vis);
}

int WidgetList::moveBy(const string title, int x, int y) {
	int
		idx;

	idx=getIndex(title);
    if (idx < 0)
        return -1;
    return (moveBy(idx,x,y));
}

int WidgetList::moveBy(unsigned int idx, int x, int y) {
	deque<widdata>::iterator
		pinc;
	widdata
        wd;
	unsigned int
		i;

	tlock();
    if (idx >= _list.size()) {
		tunlock();
        return -1;
	}
//    pinc=&_list[idx];
	for (i=0, pinc=_list.begin(); i<idx; pinc++,i++);
	(*pinc).x=(*pinc).x+x;	
	(*pinc).y=(*pinc).y+y;	
	(*pinc).moved=true;
	tunlock();
    return 0;
}

int WidgetList::moveTo(const string title, int x, int y) {
	int
		idx;

	idx=getIndex(title);
    if (idx < 0)
        return -1;
    return (moveTo(idx,x,y));
}

int WidgetList::moveTo(unsigned int idx, int x, int y) {
	deque<widdata>::iterator
		pinc;
	widdata
        wd;
	unsigned int
		i;

	tlock();
    if (idx >= _list.size()) {
		tunlock();
        return -1;
	}
//	pinc=&_list[idx];
	for (i=0,pinc=_list.begin(); i<idx; pinc++,i++);
	(*pinc).x=x;	
	(*pinc).y=y;	
	(*pinc).moved=true;
	tunlock();
    return 0;
}

int WidgetList::moved(const string title) {
	int
		idx;

	idx=getIndex(title);
    if (idx < 0)
        return -1;
	return (moved(idx));
}

int WidgetList::moved(unsigned int idx) {
	deque<widdata>::iterator
		pinc;
	unsigned int
		i;

	tlock();
    if (idx >= _list.size()) {
		tunlock();
        return -1;
	}
	for (i=0, pinc=_list.begin(); i<idx; pinc++,i++);
	(*pinc).moved=false;
	tunlock();
	return 0;
}

int WidgetList::toFront(const string title) {
	deque<widdata>::iterator
		pinc;
	widdata
        wd;

	for (pinc=_list.begin(); pinc<_list.end(); pinc++) {
		wd=(*pinc);
		if ((wd.name) == title) {
			wd=_list.front();		
			wd.widp->outFocus();
			wd.moved=true;
			wd=(*pinc);
			_list.erase(pinc);
			wd.moved=true;
			wd.widp->inFocus();
			_list.push_front(wd);
			return 0;
		}
	}
	return -1;
}

int WidgetList::toFront(unsigned int idx) {
	deque<widdata>::iterator
		pinc;
	widdata
        wd;
	unsigned int
		i;

	for (pinc=_list.begin(),i=0; pinc<_list.end(); pinc++, i++) {
		if (i == idx) {
			wd=_list.front();		
			wd.widp->outFocus();
			wd.moved=true;
			wd=(*pinc);
			_list.erase(pinc);
			wd.moved=true;
			wd.widp->inFocus();
			_list.push_front(wd);
			return 0;
		}
	}
	return -1;
}

int WidgetList::toBack(const string title) {
	deque<widdata>::iterator
		pinc;
	widdata
        wd;

	for (pinc=_list.begin(); pinc<_list.end(); pinc++) {
		wd=(*pinc);
		if ((wd.name) == title) {
			_list.erase(pinc);
			wd.moved=true;
			wd.widp->outFocus();
			_list.push_back(wd);
			wd=_list.front();		
			wd.widp->inFocus();
			wd.moved=true;
			return 0;
		}
	}
	return -1;
}

int WidgetList::toBack(unsigned int idx) {
	deque<widdata>::iterator
		pinc;
	widdata
        wd;
	unsigned int
		i;

	for (pinc=_list.begin(),i=0; pinc<_list.end(); pinc++, i++) {
		wd=(*pinc);
		if (i == idx) {
			_list.erase(pinc);
			wd.moved=true;
			wd.widp->outFocus();
			_list.push_back(wd);
			wd=_list.front();		
			wd.widp->inFocus();
			wd.moved=true;
			return 0;
		}
	}
	return -1;
}
