#ifndef __WINDOW_H__
#define __WINDOW_H__

#include "Char.H"
#include "Widget.H"
#include "WidgetList.H"
#include "Text.H"
#include "TextArea.H"
#include "Grid.H"

class Window:public Widget {
	public:
		Window(int wdth, int hght, bool brdr=false, bool shdw=false,
			const string ttl="");
		virtual ~Window();
		virtual widstat input(Char inp);
		virtual const Grid &draw() { if (_rebld) update(); return (*_grd); }
		virtual bool update();
		virtual unsigned int height() const { return (_height); }
		virtual unsigned int width() const { return (_width); }
		virtual void title(const string &ttl, bool brdr=true) {
				_wtitle=ttl; _border=brdr; _rebld=true;  }
		virtual void border(bool brdr=true) { _border=brdr; _rebld=true; }
		virtual void shadow(bool shdw=true) { _shadow=shdw; _rebld=true; }
		virtual widstat style(Char stile);
		virtual widstat gotFocus();
		virtual void lostFocus();
		virtual int add(string name, Widget *wgt, unsigned int xoff,
				unsigned int yoff, Char activator=0x0);
		virtual int remove(const string &name);
		virtual const Widget *get(unsigned int idx=0);
		virtual const Widget *get(const string &name);
		virtual void open();
		virtual void close();
	protected:
		static int brdrsym_top;
		static int brdrsym_side;
		static int brdrsym_bot;
		static int brdrsym_ulc;
		static int brdrsym_urc;
		static int brdrsym_llc;
		static int brdrsym_lrc;
		static int brdrsym_tfl;
		static int brdrsym_tfr;
		static int brdrsym_shadow;
		pthread_mutex_t _gridlock;
		int _width;
		int _height;
		bool _border;
		bool _shadow;
		bool _rebld;
		WidgetList _widlist;
		Char _stile;
		string _wtitle;
		Grid *_grd;
		string _focwid;

		virtual void clearWin();
		virtual void drawBorder();
		virtual void drawShadow();
	private:
		Window(const Window &);
		Window &operator=(const Window &);
};

#endif // __WINDOW_H__
