#include "YahooProfile.H"
#include "StrUtil.H"
#include <stdio.h>
#include <string.h>

#include "Logger.H"
extern Logger logger;

YahooProfile::YahooProfile(const string hostname, unsigned int port) {
	_sock=new Socket(hostname, port);
	initvars();
}

YahooProfile::~YahooProfile() {
	delete(_sock);
}

void YahooProfile::initvars() {
	_content="";
	_who="";
	_name="";
	_location="";
	_age="";
	_mstatus="";
	_sex="";
	_occupation="";
	_quote="";
	_hobbies="";
	_news="";
	_picture="";
	_online=false;
}

int YahooProfile::fetch(const string who) {
	initvars();
	_who=who;
	if (retreive())
		return -1;
	if (parse())
		return 1;
	return 0;
}

int YahooProfile::retreive() {
	char buf[32768];
	int len;
	sprintf(buf,"GET /%s HTTP/1.0\n\n",_who.c_str());
	if ((*_sock).open())
		return -1;
	(*_sock).write(buf,strlen(buf));
	if ((len=(*_sock).read(buf,sizeof(buf)))<=0)
		return -2;
	buf[len]=0;	
	_content=buf;
	return 0;
}

int YahooProfile::parse() {
	StrUtil sutil;
	int strt, end;
	
	if ((strstr(_content.c_str(), "\n<title>User not found</title>\n")))
		return 1;
	strt=findPicture(_who);
	while ((sutil.findTagBounds(_content.c_str(),NULL,strt,end))==0) {
		_content.erase(strt,end-strt);
	}
	getElement("Yahoo! ID",_who);
	getElement("Real&nbsp;Name",_name);
	getElement("Location",_location);
	getElement("Age",_age);
	getElement("Marital&nbsp;Status",_mstatus);
	getElement("Gender",_sex);
	getElement("Occupation",_occupation);
	getElement("Favorite Quote\"","\"",_quote);
	sutil.straightReplace("&quot;","\"",_quote,true);
	getElement("More About MeHobbies: ","&nbsp;",_hobbies);
	getElement("More About MeHobbies: ","Latest News: ",_hobbies);
	getElement("Latest News: ","&nbsp;",_news);
	if ((containsElement("I'm online now!\n\nSend me a message"))==0)
		_online=true;
	return 0;
}

int YahooProfile::getElement(const string name, string &value) {
	string pattern="\n";
	pattern+=name;
	pattern+=":\n";
	return (getElement(pattern,"\n",value));
}

int YahooProfile::getElement(const string pattern, const string end,
		string &value) {
	char *ptr, *bptr;
	if ((ptr=strstr(_content.c_str(),pattern.c_str()))!=NULL) {
		ptr+=pattern.length();
		if (end=="\n") {
			if (*(ptr)=='\n') ++ptr;
			if (*(ptr)=='\n') ++ptr;
		}
		if ((bptr=strstr(ptr,end.c_str()))!=NULL) {
			value=_content.substr(ptr-_content.c_str(),bptr-ptr);
			return 0;
		}
	}
	return 1;
}

int YahooProfile::containsElement(const string name) {
	string pattern="\n";
	pattern+=name;
	pattern+="\n";
	if ((strstr(_content.c_str(),pattern.c_str()))) {
		return 0;
	}
	return 1;
}

int YahooProfile::findPicture(const string who) {
	char *ptr;
	char *bptr;
	string name;
	string match;
	for (unsigned int i=0; i < who.length(); i++) {
		if ((who[i]>='A') && (who[i]<='Z'))
			name+=(who[i])+'a'-'A';
		else
			name+=who[i];
	}
	match=" alt=\"";
	match+=name;
	match+="\"";
	if ((ptr=strstr(_content.c_str(),match.c_str()))==NULL)
		return 1;
	match="<img src=\"";
	while ((*ptr)!='\n') {
		if (ptr<=_content.c_str())
			return 2;
		ptr--;
	}
	if ((ptr=strstr(ptr,match.c_str()))==NULL)
		return 3;
	ptr+=match.length();
	if ((bptr=strchr(ptr,'"'))==NULL)
		return 4;
	_picture=_content.substr(ptr-_content.c_str(),bptr-ptr);
	if (_picture=="http://us.i1.yimg.com/us.yimg.com/i/ppl/no_photo.gif")
		_picture="";
	return 0;
}
