#ifndef __YAHOOPROFILE_H__
#define __YAHOOPROFILE_H__

#include <string>
#include "Socket.H"

class YahooProfile {
	public:
		YahooProfile(const string hostname="profiles.yahoo.com",
				unsigned int port=80);
		~YahooProfile();
		int fetch(const string who);
		void getVars(string &who, string &name, string &location, string &age,
				string &mstatus, string &sex, string &occupation, string &quote,
				string &hobbies, string &news, string &picture, bool &online) {
			who=_who; name=_name; location=_location; age=_age;
			mstatus=_mstatus; sex=_sex; occupation=_occupation; quote=_quote;
			hobbies=_hobbies; news=_news; picture=_picture; online=_online;
		}
	private:
		void initvars();
		int retreive();
		int parse();
		int getElement(const string name, string &value);
		int getElement(const string pattern, const string end, string &value);
		int containsElement(const string name);
		int findPicture(const string who);
		YahooProfile(const YahooProfile &);
		YahooProfile &operator=(const YahooProfile &);
		Socket *_sock;
		string _content;
		string _who;
		string _name;
		string _location;
		string _age;
		string _mstatus;
		string _sex;
		string _occupation;
		string _quote;
		string _hobbies;
		string _news;
		string _picture;
		bool _online;
};

#endif // __YAHOOPROFILE_H__
