#include "YahooProto.H"
#include "Logger.H"
#include "Screen.H"
#include "Window.H"
#include "FStrList.H"
#include "FStrPairList.H"
#include "CFCommand.H"
#include "CFMainWin.H"
#include <pwd.h>
#include <unistd.h>
#include <sys/stat.h>
#include <string.h>
#include <signal.h>

#ifdef DEBUG
#include <sys/types.h>
#include <sys/wait.h>
#include <stdio.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
void setmaxes(void);
void sighandler(int x);
#define LOGGER_OUT "/tmp/yh.out"
#else
#define LOGGER_OUT "/dev/null"
#endif

Screen *scr;
Logger logger(1,LOGGER_OUT);
const char *CURFLOO_VER="0.76F";
FStrPairList *config;
string commandfile;
string iggyfile;


int main(int argc, char **argv) {
	int
		rv;
	struct passwd
		*pwent;
	struct stat
		sbuf;
	char
		fbuf[256],
		fnam[256];
	string
		user,
		password,
		room;

#ifdef DEBUG
	setmaxes();
//	for (rv=0;rv<32;rv++) {
//		if ((rv==6) || (rv==17) || (rv==18) || (rv==20) || (rv==SIGWINCH))
//			continue;
//		signal(rv,sighandler);
//	}
#else
	signal(SIGALRM,SIG_IGN);
#endif
	freopen("/dev/null","w",stderr);
	scr=new Screen();

	if (argc > 1)
		user=argv[1];
	if (argc > 2)
		password=argv[2];
	if (argc > 3) {
		room=argv[3];
	}	
	pwent=getpwuid(getuid());
	sprintf(fbuf,"%s/.curfloo",pwent->pw_dir);
	if (stat(fbuf,&sbuf)) {
		mkdir(fbuf,(S_IRUSR|S_IWUSR|S_IXUSR));
	}
	sprintf(fnam,"%s/ignore",fbuf);
	iggyfile=fnam;
//	iggy=new FStrList(fnam);
	sprintf(fnam,"%s/config",fbuf);
	config=new FStrPairList(fnam);
	sprintf(fnam,"%s/commands",fbuf);
	commandfile=fnam;
	scr->init();
	CFMainWin win(scr->width(),scr->height(),user,password,room);
	scr->registerWindow(&win,"",0,0);
	rv=win.run();
	delete(scr);
	puts("goodbye");
	return rv;
}

#ifdef DEBUG

void sighandler(int x) {
//	char Buffer[1024];
    
logger.log("dammnit! caught a sig %d", x);
//	sprintf(Buffer,"/tmp/curfloo/core.%d",(int)time(NULL));
//	chdir("/tmp/curfloo");
//    if (fork()) {
//log.log("waiting for core to be created %d", x);
//		wait(NULL);
//		rename("/tmp/curfloo/core",Buffer);
//		exit(0);
//	}
//	else {
	if (x!=11) {
logger.log("cleaning up the screen");
		scr->bailout();
	}
logger.log("creating core fire");
		abort();
//	}
	exit(0);
}   


void setmaxes(void) {
	int i;
	struct rlimit rlim;

	for (i = 0; (0 == getrlimit(i,&rlim)); ++i) {
		rlim.rlim_cur = rlim.rlim_max;
		setrlimit(i,&rlim);
	}
}
#endif
